import{s as yt,n as $t,o as bt}from"../chunks/scheduler.85c25b89.js";import{S as wt,i as xt,g as a,s,u as h,A as Lt,h as l,f as t,c as o,j as c,v as p,y as u,k as m,o as r,a as i,w as v,d as _,t as f,x as g}from"../chunks/index.9633332f.js";import{D as R}from"../chunks/Docstring.d451fcbb.js";import{I as He}from"../chunks/IconCopyLink.a4acffac.js";function St(Ke){let $,ue,oe,ve,b,T,me,N,Ie,W,Qe="Learning Rate Schedulers",_e,M,We="This page contains the API reference documentation for learning rate schedulers included in <code>timm</code>.",fe,w,P,ce,A,De,X,Xe="Schedulers",ge,x,k,de,H,Fe,Y,Ye="Factory functions",ye,I,D,$e,F,O,be,L,z,he,V,Oe,Z,Ze="Scheduler Classes",we,d,j,Ve,ee,et=`Cosine decay with restarts.
This is described in the paper <a href="https://arxiv.org/abs/1608.03983" rel="nofollow">https://arxiv.org/abs/1608.03983</a>.`,je,te,tt=`Inspiration from
<a href="https://github.com/allenai/allennlp/blob/master/allennlp/training/learning_rate_schedulers/cosine.py" rel="nofollow">https://github.com/allenai/allennlp/blob/master/allennlp/training/learning_rate_schedulers/cosine.py</a>`,qe,ae,at='k-decay option based on <code>k-decay: A New Method For Learning Rate Schedule</code> - <a href="https://arxiv.org/abs/2004.05909" rel="nofollow">https://arxiv.org/abs/2004.05909</a>',xe,q,U,Le,S,J,Ue,le,lt="Decay the LR by a factor every time the validation loss plateaus.",Se,y,B,Je,ne,nt="Polynomial LR Scheduler w/ warmup, noise, and k-decay",Be,re,rt='k-decay option based on <code>k-decay: A New Method For Learning Rate Schedule</code> - <a href="https://arxiv.org/abs/2004.05909" rel="nofollow">https://arxiv.org/abs/2004.05909</a>',Ce,G,K,Te,C,Q,Ge,ie,it=`Hyberbolic-Tangent decay with restarts.
This is described in the paper <a href="https://arxiv.org/abs/1806.01593" rel="nofollow">https://arxiv.org/abs/1806.01593</a>`,Pe,pe,ke;return N=new He({}),A=new He({}),H=new He({}),D=new R({props:{name:"timm.scheduler.create_scheduler",anchor:"timm.scheduler.create_scheduler",parameters:[{name:"args",val:""},{name:"optimizer",val:": Optimizer"},{name:"updates_per_epoch",val:": int = 0"}],source:"https://github.com/huggingface/pytorch-image-models/blob/v0.9.7/timm/scheduler/scheduler_factory.py#L48"}}),O=new R({props:{name:"timm.scheduler.create_scheduler_v2",anchor:"timm.scheduler.create_scheduler_v2",parameters:[{name:"optimizer",val:": Optimizer"},{name:"sched",val:": str = 'cosine'"},{name:"num_epochs",val:": int = 300"},{name:"decay_epochs",val:": int = 90"},{name:"decay_milestones",val:": typing.List[int] = (90, 180, 270)"},{name:"cooldown_epochs",val:": int = 0"},{name:"patience_epochs",val:": int = 10"},{name:"decay_rate",val:": float = 0.1"},{name:"min_lr",val:": float = 0"},{name:"warmup_lr",val:": float = 1e-05"},{name:"warmup_epochs",val:": int = 0"},{name:"warmup_prefix",val:": bool = False"},{name:"noise",val:": typing.Union[float, typing.List[float]] = None"},{name:"noise_pct",val:": float = 0.67"},{name:"noise_std",val:": float = 1.0"},{name:"noise_seed",val:": int = 42"},{name:"cycle_mul",val:": float = 1.0"},{name:"cycle_decay",val:": float = 0.1"},{name:"cycle_limit",val:": int = 1"},{name:"k_decay",val:": float = 1.0"},{name:"plateau_mode",val:": str = 'max'"},{name:"step_on_epochs",val:": bool = True"},{name:"updates_per_epoch",val:": int = 0"}],source:"https://github.com/huggingface/pytorch-image-models/blob/v0.9.7/timm/scheduler/scheduler_factory.py#L60"}}),V=new He({}),j=new R({props:{name:"class timm.scheduler.CosineLRScheduler",anchor:"timm.scheduler.CosineLRScheduler",parameters:[{name:"optimizer",val:": Optimizer"},{name:"t_initial",val:": int"},{name:"lr_min",val:": float = 0.0"},{name:"cycle_mul",val:": float = 1.0"},{name:"cycle_decay",val:": float = 1.0"},{name:"cycle_limit",val:": int = 1"},{name:"warmup_t",val:" = 0"},{name:"warmup_lr_init",val:" = 0"},{name:"warmup_prefix",val:" = False"},{name:"t_in_epochs",val:" = True"},{name:"noise_range_t",val:" = None"},{name:"noise_pct",val:" = 0.67"},{name:"noise_std",val:" = 1.0"},{name:"noise_seed",val:" = 42"},{name:"k_decay",val:" = 1.0"},{name:"initialize",val:" = True"}],source:"https://github.com/huggingface/pytorch-image-models/blob/v0.9.7/timm/scheduler/cosine_lr.py#L18"}}),U=new R({props:{name:"class timm.scheduler.MultiStepLRScheduler",anchor:"timm.scheduler.MultiStepLRScheduler",parameters:[{name:"optimizer",val:": Optimizer"},{name:"decay_t",val:": typing.List[int]"},{name:"decay_rate",val:": float = 1.0"},{name:"warmup_t",val:" = 0"},{name:"warmup_lr_init",val:" = 0"},{name:"warmup_prefix",val:" = True"},{name:"t_in_epochs",val:" = True"},{name:"noise_range_t",val:" = None"},{name:"noise_pct",val:" = 0.67"},{name:"noise_std",val:" = 1.0"},{name:"noise_seed",val:" = 42"},{name:"initialize",val:" = True"}],source:"https://github.com/huggingface/pytorch-image-models/blob/v0.9.7/timm/scheduler/multistep_lr.py#L10"}}),J=new R({props:{name:"class timm.scheduler.PlateauLRScheduler",anchor:"timm.scheduler.PlateauLRScheduler",parameters:[{name:"optimizer",val:""},{name:"decay_rate",val:" = 0.1"},{name:"patience_t",val:" = 10"},{name:"verbose",val:" = True"},{name:"threshold",val:" = 0.0001"},{name:"cooldown_t",val:" = 0"},{name:"warmup_t",val:" = 0"},{name:"warmup_lr_init",val:" = 0"},{name:"lr_min",val:" = 0"},{name:"mode",val:" = 'max'"},{name:"noise_range_t",val:" = None"},{name:"noise_type",val:" = 'normal'"},{name:"noise_pct",val:" = 0.67"},{name:"noise_std",val:" = 1.0"},{name:"noise_seed",val:" = None"},{name:"initialize",val:" = True"}],source:"https://github.com/huggingface/pytorch-image-models/blob/v0.9.7/timm/scheduler/plateau_lr.py#L12"}}),B=new R({props:{name:"class timm.scheduler.PolyLRScheduler",anchor:"timm.scheduler.PolyLRScheduler",parameters:[{name:"optimizer",val:": Optimizer"},{name:"t_initial",val:": int"},{name:"power",val:": float = 0.5"},{name:"lr_min",val:": float = 0.0"},{name:"cycle_mul",val:": float = 1.0"},{name:"cycle_decay",val:": float = 1.0"},{name:"cycle_limit",val:": int = 1"},{name:"warmup_t",val:" = 0"},{name:"warmup_lr_init",val:" = 0"},{name:"warmup_prefix",val:" = False"},{name:"t_in_epochs",val:" = True"},{name:"noise_range_t",val:" = None"},{name:"noise_pct",val:" = 0.67"},{name:"noise_std",val:" = 1.0"},{name:"noise_seed",val:" = 42"},{name:"k_decay",val:" = 1.0"},{name:"initialize",val:" = True"}],source:"https://github.com/huggingface/pytorch-image-models/blob/v0.9.7/timm/scheduler/poly_lr.py#L18"}}),K=new R({props:{name:"class timm.scheduler.StepLRScheduler",anchor:"timm.scheduler.StepLRScheduler",parameters:[{name:"optimizer",val:": Optimizer"},{name:"decay_t",val:": float"},{name:"decay_rate",val:": float = 1.0"},{name:"warmup_t",val:" = 0"},{name:"warmup_lr_init",val:" = 0"},{name:"warmup_prefix",val:" = True"},{name:"t_in_epochs",val:" = True"},{name:"noise_range_t",val:" = None"},{name:"noise_pct",val:" = 0.67"},{name:"noise_std",val:" = 1.0"},{name:"noise_seed",val:" = 42"},{name:"initialize",val:" = True"}],source:"https://github.com/huggingface/pytorch-image-models/blob/v0.9.7/timm/scheduler/step_lr.py#L13"}}),Q=new R({props:{name:"class timm.scheduler.TanhLRScheduler",anchor:"timm.scheduler.TanhLRScheduler",parameters:[{name:"optimizer",val:": Optimizer"},{name:"t_initial",val:": int"},{name:"lb",val:": float = -7.0"},{name:"ub",val:": float = 3.0"},{name:"lr_min",val:": float = 0.0"},{name:"cycle_mul",val:": float = 1.0"},{name:"cycle_decay",val:": float = 1.0"},{name:"cycle_limit",val:": int = 1"},{name:"warmup_t",val:" = 0"},{name:"warmup_lr_init",val:" = 0"},{name:"warmup_prefix",val:" = False"},{name:"t_in_epochs",val:" = True"},{name:"noise_range_t",val:" = None"},{name:"noise_pct",val:" = 0.67"},{name:"noise_std",val:" = 1.0"},{name:"noise_seed",val:" = 42"},{name:"initialize",val:" = True"}],source:"https://github.com/huggingface/pytorch-image-models/blob/v0.9.7/timm/scheduler/tanh_lr.py#L18"}}),{c(){$=a("meta"),ue=s(),oe=a("p"),ve=s(),b=a("h1"),T=a("a"),me=a("span"),h(N.$$.fragment),Ie=s(),W=a("span"),W.textContent=Qe,_e=s(),M=a("p"),M.innerHTML=We,fe=s(),w=a("h2"),P=a("a"),ce=a("span"),h(A.$$.fragment),De=s(),X=a("span"),X.textContent=Xe,ge=s(),x=a("h3"),k=a("a"),de=a("span"),h(H.$$.fragment),Fe=s(),Y=a("span"),Y.textContent=Ye,ye=s(),I=a("div"),h(D.$$.fragment),$e=s(),F=a("div"),h(O.$$.fragment),be=s(),L=a("h3"),z=a("a"),he=a("span"),h(V.$$.fragment),Oe=s(),Z=a("span"),Z.textContent=Ze,we=s(),d=a("div"),h(j.$$.fragment),Ve=s(),ee=a("p"),ee.innerHTML=et,je=s(),te=a("p"),te.innerHTML=tt,qe=s(),ae=a("p"),ae.innerHTML=at,xe=s(),q=a("div"),h(U.$$.fragment),Le=s(),S=a("div"),h(J.$$.fragment),Ue=s(),le=a("p"),le.textContent=lt,Se=s(),y=a("div"),h(B.$$.fragment),Je=s(),ne=a("p"),ne.textContent=nt,Be=s(),re=a("p"),re.innerHTML=rt,Ce=s(),G=a("div"),h(K.$$.fragment),Te=s(),C=a("div"),h(Q.$$.fragment),Ge=s(),ie=a("p"),ie.innerHTML=it,Pe=s(),pe=a("p"),this.h()},l(e){const n=Lt("svelte-1phssyn",document.head);$=l(n,"META",{name:!0,content:!0}),n.forEach(t),ue=o(e),oe=l(e,"P",{}),c(oe).forEach(t),ve=o(e),b=l(e,"H1",{class:!0});var ze=c(b);T=l(ze,"A",{id:!0,class:!0,href:!0});var st=c(T);me=l(st,"SPAN",{});var ot=c(me);p(N.$$.fragment,ot),ot.forEach(t),st.forEach(t),Ie=o(ze),W=l(ze,"SPAN",{"data-svelte-h":!0}),u(W)!=="svelte-1hyn2nz"&&(W.textContent=Qe),ze.forEach(t),_e=o(e),M=l(e,"P",{"data-svelte-h":!0}),u(M)!=="svelte-k4ut34"&&(M.innerHTML=We),fe=o(e),w=l(e,"H2",{class:!0});var Ee=c(w);P=l(Ee,"A",{id:!0,class:!0,href:!0});var mt=c(P);ce=l(mt,"SPAN",{});var ct=c(ce);p(A.$$.fragment,ct),ct.forEach(t),mt.forEach(t),De=o(Ee),X=l(Ee,"SPAN",{"data-svelte-h":!0}),u(X)!=="svelte-1mh2qlv"&&(X.textContent=Xe),Ee.forEach(t),ge=o(e),x=l(e,"H3",{class:!0});var Re=c(x);k=l(Re,"A",{id:!0,class:!0,href:!0});var dt=c(k);de=l(dt,"SPAN",{});var ht=c(de);p(H.$$.fragment,ht),ht.forEach(t),dt.forEach(t),Fe=o(Re),Y=l(Re,"SPAN",{"data-svelte-h":!0}),u(Y)!=="svelte-1n2i7uc"&&(Y.textContent=Ye),Re.forEach(t),ye=o(e),I=l(e,"DIV",{class:!0});var pt=c(I);p(D.$$.fragment,pt),pt.forEach(t),$e=o(e),F=l(e,"DIV",{class:!0});var ut=c(F);p(O.$$.fragment,ut),ut.forEach(t),be=o(e),L=l(e,"H3",{class:!0});var Ne=c(L);z=l(Ne,"A",{id:!0,class:!0,href:!0});var vt=c(z);he=l(vt,"SPAN",{});var _t=c(he);p(V.$$.fragment,_t),_t.forEach(t),vt.forEach(t),Oe=o(Ne),Z=l(Ne,"SPAN",{"data-svelte-h":!0}),u(Z)!=="svelte-30m5hi"&&(Z.textContent=Ze),Ne.forEach(t),we=o(e),d=l(e,"DIV",{class:!0});var E=c(d);p(j.$$.fragment,E),Ve=o(E),ee=l(E,"P",{"data-svelte-h":!0}),u(ee)!=="svelte-142rxjd"&&(ee.innerHTML=et),je=o(E),te=l(E,"P",{"data-svelte-h":!0}),u(te)!=="svelte-z0bxov"&&(te.innerHTML=tt),qe=o(E),ae=l(E,"P",{"data-svelte-h":!0}),u(ae)!=="svelte-1wsck9y"&&(ae.innerHTML=at),E.forEach(t),xe=o(e),q=l(e,"DIV",{class:!0});var ft=c(q);p(U.$$.fragment,ft),ft.forEach(t),Le=o(e),S=l(e,"DIV",{class:!0});var Me=c(S);p(J.$$.fragment,Me),Ue=o(Me),le=l(Me,"P",{"data-svelte-h":!0}),u(le)!=="svelte-1sewxb2"&&(le.textContent=lt),Me.forEach(t),Se=o(e),y=l(e,"DIV",{class:!0});var se=c(y);p(B.$$.fragment,se),Je=o(se),ne=l(se,"P",{"data-svelte-h":!0}),u(ne)!=="svelte-16f5sza"&&(ne.textContent=nt),Be=o(se),re=l(se,"P",{"data-svelte-h":!0}),u(re)!=="svelte-1wsck9y"&&(re.innerHTML=rt),se.forEach(t),Ce=o(e),G=l(e,"DIV",{class:!0});var gt=c(G);p(K.$$.fragment,gt),gt.forEach(t),Te=o(e),C=l(e,"DIV",{class:!0});var Ae=c(C);p(Q.$$.fragment,Ae),Ge=o(Ae),ie=l(Ae,"P",{"data-svelte-h":!0}),u(ie)!=="svelte-1rx2bx1"&&(ie.innerHTML=it),Ae.forEach(t),Pe=o(e),pe=l(e,"P",{}),c(pe).forEach(t),this.h()},h(){m($,"name","hf:doc:metadata"),m($,"content",JSON.stringify(Ct)),m(T,"id","learning-rate-schedulers"),m(T,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(T,"href","#learning-rate-schedulers"),m(b,"class","relative group"),m(P,"id","schedulers"),m(P,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(P,"href","#schedulers"),m(w,"class","relative group"),m(k,"id","timm.scheduler.create_scheduler"),m(k,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(k,"href","#timm.scheduler.create_scheduler"),m(x,"class","relative group"),m(I,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(z,"id","timm.scheduler.CosineLRScheduler"),m(z,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(z,"href","#timm.scheduler.CosineLRScheduler"),m(L,"class","relative group"),m(d,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,n){r(document.head,$),i(e,ue,n),i(e,oe,n),i(e,ve,n),i(e,b,n),r(b,T),r(T,me),v(N,me,null),r(b,Ie),r(b,W),i(e,_e,n),i(e,M,n),i(e,fe,n),i(e,w,n),r(w,P),r(P,ce),v(A,ce,null),r(w,De),r(w,X),i(e,ge,n),i(e,x,n),r(x,k),r(k,de),v(H,de,null),r(x,Fe),r(x,Y),i(e,ye,n),i(e,I,n),v(D,I,null),i(e,$e,n),i(e,F,n),v(O,F,null),i(e,be,n),i(e,L,n),r(L,z),r(z,he),v(V,he,null),r(L,Oe),r(L,Z),i(e,we,n),i(e,d,n),v(j,d,null),r(d,Ve),r(d,ee),r(d,je),r(d,te),r(d,qe),r(d,ae),i(e,xe,n),i(e,q,n),v(U,q,null),i(e,Le,n),i(e,S,n),v(J,S,null),r(S,Ue),r(S,le),i(e,Se,n),i(e,y,n),v(B,y,null),r(y,Je),r(y,ne),r(y,Be),r(y,re),i(e,Ce,n),i(e,G,n),v(K,G,null),i(e,Te,n),i(e,C,n),v(Q,C,null),r(C,Ge),r(C,ie),i(e,Pe,n),i(e,pe,n),ke=!0},p:$t,i(e){ke||(_(N.$$.fragment,e),_(A.$$.fragment,e),_(H.$$.fragment,e),_(D.$$.fragment,e),_(O.$$.fragment,e),_(V.$$.fragment,e),_(j.$$.fragment,e),_(U.$$.fragment,e),_(J.$$.fragment,e),_(B.$$.fragment,e),_(K.$$.fragment,e),_(Q.$$.fragment,e),ke=!0)},o(e){f(N.$$.fragment,e),f(A.$$.fragment,e),f(H.$$.fragment,e),f(D.$$.fragment,e),f(O.$$.fragment,e),f(V.$$.fragment,e),f(j.$$.fragment,e),f(U.$$.fragment,e),f(J.$$.fragment,e),f(B.$$.fragment,e),f(K.$$.fragment,e),f(Q.$$.fragment,e),ke=!1},d(e){e&&(t(ue),t(oe),t(ve),t(b),t(_e),t(M),t(fe),t(w),t(ge),t(x),t(ye),t(I),t($e),t(F),t(be),t(L),t(we),t(d),t(xe),t(q),t(Le),t(S),t(Se),t(y),t(Ce),t(G),t(Te),t(C),t(Pe),t(pe)),t($),g(N),g(A),g(H),g(D),g(O),g(V),g(j),g(U),g(J),g(B),g(K),g(Q)}}}const Ct={local:"learning-rate-schedulers",sections:[{local:"schedulers",sections:[{local:"timm.scheduler.create_scheduler",title:"Factory functions"},{local:"timm.scheduler.CosineLRScheduler",title:"Scheduler Classes"}],title:"Schedulers"}],title:"Learning Rate Schedulers"};function Tt(Ke){return bt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Rt extends wt{constructor($){super(),xt(this,$,Tt,St,yt,{})}}export{Rt as component};
